%define		pname proftpd
%define		mversion 1.2.10
%define		pversion 1.2.10
%define 	bversion 101
%define		rpmrelease iworx
%define		rundir /var/run/proftpd
%define		user  proftpd
%define		iworxdir /home/interworx

%define 	debug_package %{nil}

##
# You can specify additional modules on the RPM build line by 
# specifying flags like:
#
#   --with mod_radius
#
# The following modules/support can be added in this manner:
#
#   mod_radius
#   mod_ldap
#   mod_wrap
#   mod_sql_postgres
#   mod_ifsession
#
# Default mods are ratio, readme, sql, sql_mysql
##

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#

%define 	build_rht_90   0
%define		build_cos_3x   0
%define		build_fdr_10   0
%define		build_fdr_20   0
%define		build_fdr_30   0
%define		build_fdr_40   0
%define		build_whb_3x   0
%define		build_rhe_2x   0
%define		build_rhe_3x   0
%define		build_rhe_4x   0

%define		build_unk      1

# Command Line Overrides
%{?_with_rht90:   	%{expand: %%define build_rht_90   1}}
%{?_with_cos3x: 	%{expand: %%define build_cos_3x   1}}
%{?_with_fdr10: 	%{expand: %%define build_fdr_10   1}}
%{?_with_fdr20: 	%{expand: %%define build_fdr_20   1}}
%{?_with_fdr30: 	%{expand: %%define build_fdr_30   1}}
%{?_with_fdr40: 	%{expand: %%define build_fdr_40   1}}
%{?_with_whb3x: 	%{expand: %%define build_whb_3x   1}}
%{?_with_rhe2x: 	%{expand: %%define build_rhe_2x   1}}
%{?_with_rhe3x: 	%{expand: %%define build_rhe_3x   1}}
%{?_with_rhe4x: 	%{expand: %%define build_rhe_4x   1}}

%{?_with_unk: 		%{expand: %%define build_unk      1}}

# Distro Statements
%if %{build_rht_90}
%define		oscode rht90
%define 	ostype RedHat 9
BuildRequires:	mysql-iworx
%define		ccflags %{optflags} -I%{iworxdir}/include/mysql -I/usr/kerberos/include
%define		ldflags %{optflags} -L%{iworxdir}/lib/mysql
%define		build_unk 0
%endif

%if %{build_cos_3x}
%define		oscode cos3x
%define 	ostype CentOS 3.x
BuildRequires:	mysql-iworx
%define		ccflags %{optflags} -I%{iworxdir}/include/mysql -I/usr/kerberos/include
%define		ldflags %{optflags} -L%{iworxdir}/lib/mysql
%define		build_unk 0
%endif

%if %{build_fdr_10}
%define		oscode fdr10
%define 	ostype Fedora Core 1
BuildRequires:	mysql-iworx
%define		ccflags %{optflags} -I%{iworxdir}/include/mysql -I/usr/kerberos/include
%define		ldflags %{optflags} -L%{iworxdir}/lib/mysql
%define		build_unk 0
%endif

%if %{build_fdr_20}
%define		oscode fdr20
%define 	ostype Fedora Core 2
BuildRequires:	mysql-iworx
%define		ccflags %{optflags} -I%{iworxdir}/include/mysql -I/usr/kerberos/include
%define		ldflags %{optflags} -L%{iworxdir}/lib/mysql
%define		build_unk 0
%endif

%if %{build_fdr_30}
%define		oscode fdr30
%define 	ostype Fedora Core 3
BuildRequires:	mysql-iworx
%define		ccflags %{optflags} -I%{iworxdir}/include/mysql -I/usr/kerberos/include
%define		ldflags %{optflags} -L%{iworxdir}/lib/mysql
%define		build_unk 0
%endif

%if %{build_fdr_40}
%define		oscode fdr40
%define 	ostype Fedora Core 4
BuildRequires:	mysql-iworx
%define		ccflags %{optflags} -I%{iworxdir}/include/mysql -I/usr/kerberos/include
%define		ldflags %{optflags} -L%{iworxdir}/lib/mysql
%define		build_unk 0
%endif

%if %{build_whb_3x}
%define		oscode whb3x
%define 	ostype White Box 3.x
BuildRequires:	mysql-iworx
%define		ccflags %{optflags} -I%{iworxdir}/include/mysql -I/usr/kerberos/include
%define		ldflags %{optflags} -L%{iworxdir}/lib/mysql
%define		build_unk 0
%endif

%if %{build_rhe_2x}
%define		oscode rhe2x
%define 	ostype RedHat Enterprise 2.x
BuildRequires:	mysql-iworx
%define		ccflags %{optflags} -I%{iworxdir}/include/mysql -I/usr/kerberos/include
%define		ldflags %{optflags} -L%{iworxdir}/lib/mysql
%define		build_unk 0
%endif

%if %{build_rhe_3x}
%define		oscode rhe3x
%define 	ostype RedHat Enterprise 3.x
BuildRequires:	mysql-iworx
%define		ccflags %{optflags} -I%{iworxdir}/include/mysql -I/usr/kerberos/include
%define		ldflags %{optflags} -L%{iworxdir}/lib/mysql
%define		build_unk 0
%endif

%if %{build_rhe_4x}
%define		oscode rhe4x
%define 	ostype RedHat Enterprise 4.x
BuildRequires:	mysql-iworx
%define		ccflags %{optflags} -I%{iworxdir}/include/mysql -I/usr/kerberos/include
%define		ldflags %{optflags} -L%{iworxdir}/lib/mysql
%define		build_unk 0
%endif

%define	release %{bversion}.%{oscode}.%{rpmrelease}

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		oscode unk
%define 	ostype Unknown Distribution
%define		release %{bversion}.%{rpmrelease}
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary:	ProFTPD -- Professional FTP Server.
Name:		%{pname}
Version:	%{pversion}
Release: 	%{release}
License:	GPL

Group:		System Environment/Daemons
Source0:	%{name}-%{pversion}.tar.gz
URL:		http://www.proftpd.org/

Distribution:	InterWorx-HAL
Vendor:         NEXCESS.NET L.L.C
Packager:	Chris Wells <clwells@nexcess.net>

BuildRoot:	%{_tmppath}/%{name}-%{version}-root

Provides:	ftpserver
Prereq:		fileutils

Source1:	proftpd.conf

%description
ProFTPD is an enhanced FTP server with a focus toward simplicity, security,
and ease of configuration.  It features a very Apache-like configuration
syntax, and a highly customizable server infrastructure, including support for
multiple 'virtual' FTP servers, anonymous FTP, and permission-based directory
visibility.

%prep

[ -n %{buildroot} ] && rm -rf %{buildroot}

[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%setup -q -n %{name}-%{mversion}

# Try detecting newest gcc (some distributions have got more then one compiler)
# and write it on a temp file 

[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{name}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{name}-%{pversion}-gcc
fi

# Display compilation flags and OS with colors ;)

[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags

# We have gcc written in a temp file
export CC="`cat %{_tmppath}/%{name}-%{pversion}-gcc` %{ccflags}"

# Delete gcc temp file
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

MODULES="mod_ratio:mod_readme:mod_sql:mod_sql_mysql:mod_tls:mod_rewrite"
MODULES="${MODULES}%{?_with_mod_radius::mod_radius}"
MODULES="${MODULES}%{?_with_mod_ldap::mod_ldap}"
MODULES="${MODULES}%{?_with_mod_wrap::mod_wrap}"
MODULES="${MODULES}%{?_with_mod_sql_postgres::mod_sql_postgres}"
MODULES="${MODULES}%{?_with_mod_ifsession::mod_ifsession}"

export LDFLAGS="%{ldflags}"

./configure                               \
	--prefix=%{_prefix}               \
	--bindir=%{_bindir}               \
	--mandir=%{_mandir}               \
	--localstatedir=%{_localstatedir} \
	--libdir=%{_libdir}               \
	--datadir=%{_datadir}             \
	--includedir=%{_includedir}       \
	--sysconfdir=%{_sysconfdir}       \
	--disable-shared                  \
	--with-modules=${MODULES}

%build

%{__make} %{?_smp_mflags}

%install

%{__make}                                            \
	prefix=%{buildroot}%{_prefix}                \
	bindir=%{buildroot}%{_bindir}                \
	sbindir=%{buildroot}%{_sbindir}              \
	mandir=%{buildroot}%{_mandir}                \
	libdir=%{buildroot}%{_libdir}                \
	localstatedir=%{buildroot}%{_localstatedir}  \
	datadir=%{buildroot}%{_datadir}              \
	includedir=%{buildroot}%{_includedir}        \
	sysconfdir=%{buildroot}%{_sysconfdir}        \
	rundir=%{buildroot}%{rundir}                 \
	INSTALL_USER=`id -un` INSTALL_GROUP=`id -gn` \
	install

mkdir -p %{buildroot}/etc/pam.d
mkdir -p %{buildroot}/var/log/ftpd

install -m 644 contrib/dist/rpm/ftp.pamd %{buildroot}/etc/pam.d/ftp

mkdir -p %{buildroot}/etc/rc.d/init.d
sed -e '/FTPSHUT=/c\' \
	-e 'FTPSHUT=%{_prefix}/sbin/ftpshut' \
	contrib/dist/rpm/proftpd.init.d \
		> contrib/dist/rpm/proftpd.init.d.tmp
mv --force contrib/dist/rpm/proftpd.init.d.tmp contrib/dist/rpm/proftpd.init.d
install -m 755 contrib/dist/rpm/proftpd.init.d %{buildroot}/etc/rc.d/init.d/proftpd

mkdir -p %{buildroot}/etc/logrotate.d/
install -m 644 contrib/dist/rpm/proftpd.logrotate %{buildroot}/etc/logrotate.d/proftpd

# We don't want this dangling symlinks to make it into the RPM
rm -f contrib/README.mod_sql
mkdir -p %{buildroot}%{_docdir}

rm -f %{buildroot}%{_docdir}/*
install -m 644 COPYING CREDITS ChangeLog NEWS %{buildroot}%{_docdir}

cp -f %{SOURCE1} %{buildroot}%{_sysconfdir}

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%pre

# make the proftpd group
/bin/grep "^%{user}:" /etc/group >/dev/null || \
	groupadd -r %{user}

# make the proftpd user
/bin/grep "^%{user}:" /etc/passwd >/dev/null || \
	/usr/sbin/useradd -g %{user} -d /tmp -s /bin/true -c %{name} -r -m %{user}

%postun

# kill the proftpd user
/bin/grep "^%{user}:" /etc/passwd >/dev/null || \
	userdel -r %{user}

%post

chkconfig --level 345 proftpd on

service proftpd start

%preun
if [ "$1" = 0 ]; then
	if [ -d %{rundir} ]; then
		rm -rf %{rundir}/*
	fi
	/sbin/chkconfig --del proftpd
fi

%files
%defattr(-,root,root)
%attr(0755,root,root) %{_sbindir}/*
%attr(0755,root,root) %{_bindir}/*
%attr(0644,root,root) %{_sysconfdir}/logrotate.d/proftpd
%attr(0751,root,root) %dir %{rundir}
%attr(0700,root,root) %{_sysconfdir}/rc.d/init.d/proftpd
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/pam.d/ftp
%attr(0640,root,root) %config(noreplace) %{_sysconfdir}/proftpd.conf

%doc
%attr(0644,root,root) %{_datadir}/doc/COPYING
%attr(0644,root,root) %{_datadir}/doc/CREDITS
%attr(0644,root,root) %{_datadir}/doc/ChangeLog
%attr(0644,root,root) %{_datadir}/doc/NEWS
%attr(0644,root,root) %{_datadir}/man/man1/ftpcount.1.gz
%attr(0644,root,root) %{_datadir}/man/man1/ftptop.1.gz
%attr(0644,root,root) %{_datadir}/man/man1/ftpwho.1.gz
%attr(0644,root,root) %{_datadir}/man/man5/xferlog.5.gz
%attr(0644,root,root) %{_datadir}/man/man8/ftpshut.8.gz
%attr(0644,root,root) %{_datadir}/man/man8/proftpd.8.gz
%attr(0644,root,root) %{_datadir}/man/man8/ftpdctl.8.gz

%changelog
* Sat Sep 18 2004 Chris Wells <clwells@nexcess.net>
- Added 'AuthOrder' to the default proftpd.conf
* Sun Sep 4 2004 Chris Wells <clwells@nexcess.net>
- updated for 1.2.10
* Wed Aug 27 2003 Chris Wells <clwells@nexcess.net>
- initial release
